'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Slider = require('./Slider');

var _Slider2 = _interopRequireDefault(_Slider);

var _Track = require('./Track');

var _Track2 = _interopRequireDefault(_Track);

var _ValueTransformer = require('./ValueTransformer');

var _ValueTransformer2 = _interopRequireDefault(_ValueTransformer);

var _util = require('./util');

var _propTypes = require('./propTypes');

var _defaultClassNames = require('./defaultClassNames');

var _defaultClassNames2 = _interopRequireDefault(_defaultClassNames);

// Helpers
function isNewStep(component, value, oldValue) {
  return Math.abs(value - oldValue) >= component.props.step;
}

function getKeyBySlider(component, slider) {
  if (slider === component.refs.sliderMin) {
    return 'min';
  }

  return 'max';
}

function getKeyByPosition(component, position) {
  if (component.isMultiValue) {
    var distanceToMin = (0, _util.distanceTo)(position, component.state.positions.min);
    var distanceToMax = (0, _util.distanceTo)(position, component.state.positions.max);

    if (distanceToMin < distanceToMax) {
      return 'min';
    }
  }

  return 'max';
}

function getKeys(component) {
  if (component.isMultiValue) {
    return ['max', 'min'];
  }

  return ['max'];
}

// Constants
var KeyCode = {
  LEFT_ARROW: 37,
  RIGHT_ARROW: 39
};

// Class

var InputRange = (function (_React$Component) {
  _inherits(InputRange, _React$Component);

  function InputRange(props) {
    _classCallCheck(this, InputRange);

    _get(Object.getPrototypeOf(InputRange.prototype), 'constructor', this).call(this, props);

    // Initial state
    var state = {
      didChange: false,
      percentages: {
        min: 0,
        max: 0
      },
      positions: {
        min: { x: 0, y: 0 },
        max: { x: 0, y: 0 }
      },
      values: {
        min: 0,
        max: 0
      }
    };

    this.state = state;
    this.valueTransformer = new _ValueTransformer2['default'](this);
    this.isMultiValue = this.props.hasOwnProperty('defaultValues') || this.props.hasOwnProperty('values');

    // Auto-bind
    (0, _util.autobind)(['handleSliderMouseMove', 'handleSliderKeyDown', 'handleTrackMouseDown'], this);
  }

  // Life Cycle

  _createClass(InputRange, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setPositionsByProps(this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var props = (0, _util.omit)(nextProps, ['defaultValue', 'defaultValues']);

      this.setPositionsByProps(props);
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      var currentProps = this.props;
      var currentState = this.state;
      var shouldUpdate = currentState.values.min !== nextState.values.min || currentState.values.max !== nextState.values.max || currentState.value !== nextState.value || currentProps.minValue !== nextProps.minValue || currentProps.maxValue !== nextProps.maxValue;

      return shouldUpdate;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (this.props.onChange && this.state.didChange) {
        var results = this.state.values.max;

        if (this.isMultiValue) {
          results = this.state.values;
        }

        this.props.onChange(this, results);
      }

      this.setState({
        didChange: true
      });
    }

    // Getters / Setters
  }, {
    key: 'setPositions',

    // Methods
    value: function setPositions(positions) {
      var values = {
        min: this.valueTransformer.valueFromPosition(positions.min),
        max: this.valueTransformer.valueFromPosition(positions.max)
      };

      var transformedValues = {
        min: this.valueTransformer.stepValueFromValue(values.min),
        max: this.valueTransformer.stepValueFromValue(values.max)
      };

      var transformedPositions = {
        min: this.valueTransformer.positionFromValue(transformedValues.min),
        max: this.valueTransformer.positionFromValue(transformedValues.max)
      };

      var transformedPercentages = {
        min: this.valueTransformer.percentageFromPosition(transformedPositions.min),
        max: this.valueTransformer.percentageFromPosition(transformedPositions.max)
      };

      var isStep = isNewStep(this, transformedValues.min, this.state.values.min) || isNewStep(this, transformedValues.max, this.state.values.max);
      var isValid = !this.isMultiValue || transformedValues.min < transformedValues.max;
      var shouldUpdate = isStep && isValid;

      if (shouldUpdate) {
        var state = {
          percentages: transformedPercentages,
          positions: transformedPositions,
          values: transformedValues
        };

        this.setState(state);
      }
    }
  }, {
    key: 'setPosition',
    value: function setPosition(slider, position) {
      var key = slider && slider.props.type || getKeyByPosition(this, position);
      var positions = (0, _util.extend)({}, this.state.positions, _defineProperty({}, key, position));

      this.setPositions(positions);
    }
  }, {
    key: 'setPositionByValue',
    value: function setPositionByValue(slider, value) {
      if (!(0, _util.isNumber)(value)) {
        return;
      }

      var validValue = (0, _util.clamp)(value, this.props.minValue, this.props.maxValue);
      var position = this.valueTransformer.positionFromValue(validValue);

      this.setPosition(slider, position);
    }
  }, {
    key: 'setPositionsByValues',
    value: function setPositionsByValues(values) {
      if (!values || !(0, _util.isNumber)(values.min) || !(0, _util.isNumber)(values.max)) {
        return;
      }

      var validValues = {
        min: (0, _util.clamp)(values.min, this.props.minValue, this.props.maxValue),
        max: (0, _util.clamp)(values.max, this.props.minValue, this.props.maxValue)
      };

      var positions = {
        min: this.valueTransformer.positionFromValue(validValues.min),
        max: this.valueTransformer.positionFromValue(validValues.max)
      };

      this.setPositions(positions);
    }
  }, {
    key: 'setPositionsByProps',
    value: function setPositionsByProps(props) {
      if (this.isMultiValue) {
        var values = !(0, _util.isEmpty)(props.values) ? props.values : props.defaultValues;

        this.setPositionsByValues(values);
      } else {
        var value = (0, _util.isNumber)(props.value) ? props.value : props.defaultValue;

        this.setPositionByValue(this.refs.sliderMax, value);
      }
    }
  }, {
    key: 'incrementValue',
    value: function incrementValue(slider) {
      var key = getKeyBySlider(this, slider);
      var value = this.state.values[key] + this.props.step;

      this.setPositionByValue(slider, value);
    }
  }, {
    key: 'decrementValue',
    value: function decrementValue(slider) {
      var key = getKeyBySlider(this, slider);
      var value = this.state.values[key] - this.props.step;

      this.setPositionByValue(slider, value);
    }

    // Handlers
  }, {
    key: 'handleSliderMouseMove',
    value: function handleSliderMouseMove(slider, event) {
      if (this.props.disabled) {
        return;
      }

      var position = this.valueTransformer.positionFromEvent(event);

      this.setPosition(slider, position);
    }
  }, {
    key: 'handleSliderKeyDown',
    value: function handleSliderKeyDown(slider, event) {
      if (this.props.disabled) {
        return;
      }

      switch (event.keyCode) {
        case KeyCode.LEFT_ARROW:
          this.decrementValue(slider);
          break;

        case KeyCode.RIGHT_ARROW:
          this.incrementValue(slider);
          break;

        default:
          break;
      }
    }
  }, {
    key: 'handleTrackMouseDown',
    value: function handleTrackMouseDown(track, position) {
      if (this.props.disabled) {
        return;
      }

      this.setPosition(null, position);
    }

    // Render
  }, {
    key: 'renderSliders',
    value: function renderSliders() {
      var classNames = this.props.classNames;
      var sliders = [];
      var keys = getKeys(this);

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = keys[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var key = _step.value;

          var value = this.state.values[key];
          var percentage = this.state.percentages[key];
          var ref = 'slider' + (0, _util.captialize)(key);

          var _props = this.props;
          var maxValue = _props.maxValue;
          var minValue = _props.minValue;

          if (key === 'min') {
            maxValue = this.state.values.max;
          } else {
            minValue = this.state.values.min;
          }

          var slider = _react2['default'].createElement(_Slider2['default'], {
            classNames: classNames,
            key: key,
            maxValue: maxValue,
            minValue: minValue,
            onSliderKeyDown: this.handleSliderKeyDown,
            onSliderMouseMove: this.handleSliderMouseMove,
            percentage: percentage,
            ref: ref,
            type: key,
            value: value });

          sliders.push(slider);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator['return']) {
            _iterator['return']();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return sliders;
    }
  }, {
    key: 'renderHiddenInputs',
    value: function renderHiddenInputs() {
      var inputs = [];
      var keys = getKeys(this);

      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = keys[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var key = _step2.value;

          var _name = this.isMultiValue ? '' + this.props.name + (0, _util.captialize)(key) : this.props.name;

          var input = _react2['default'].createElement('input', { type: 'hidden', name: _name });
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2['return']) {
            _iterator2['return']();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      return inputs;
    }
  }, {
    key: 'render',
    value: function render() {
      var classNames = this.props.classNames;
      var componentClassName = classNames.component;

      if (this.props.disabled) {
        componentClassName = componentClassName + ' is-disabled';
      }

      return _react2['default'].createElement(
        'div',
        {
          'aria-disabled': this.props.disabled,
          ref: 'inputRange',
          className: componentClassName },
        _react2['default'].createElement(
          'span',
          { className: classNames.labelMin },
          _react2['default'].createElement(
            'span',
            { className: classNames.labelContainer },
            this.props.minValue
          )
        ),
        _react2['default'].createElement(
          _Track2['default'],
          {
            classNames: classNames,
            ref: 'track',
            percentages: this.state.percentages,
            onTrackMouseDown: this.handleTrackMouseDown },
          this.renderSliders()
        ),
        _react2['default'].createElement(
          'span',
          { className: classNames.labelMax },
          _react2['default'].createElement(
            'span',
            { className: classNames.labelContainer },
            this.props.maxValue
          )
        ),
        this.renderHiddenInputs()
      );
    }
  }, {
    key: 'trackClientRect',
    get: function get() {
      var track = this.refs.track;

      return track && track.clientRect;
    }
  }]);

  return InputRange;
})(_react2['default'].Component);

InputRange.propTypes = {
  ariaLabelledby: _react2['default'].PropTypes.string,
  classNames: _react2['default'].PropTypes.objectOf(_react2['default'].PropTypes.string),
  defaultValue: _propTypes.maxMinValuePropType,
  defaultValues: _propTypes.maxMinValuePropType,
  disabled: _react2['default'].PropTypes.bool,
  maxValue: _propTypes.maxMinValuePropType,
  minValue: _propTypes.maxMinValuePropType,
  name: _react2['default'].PropTypes.string,
  onChange: _react2['default'].PropTypes.func,
  step: _react2['default'].PropTypes.number,
  value: _propTypes.maxMinValuePropType,
  values: _propTypes.maxMinValuePropType
};

InputRange.defaultProps = {
  classNames: _defaultClassNames2['default'],
  disabled: false,
  minValue: 0,
  maxValue: 10,
  step: 1
};

exports['default'] = InputRange;
module.exports = exports['default'];