'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _util = require('./util');

var ValueTransformer = (function () {
  function ValueTransformer(component) {
    _classCallCheck(this, ValueTransformer);

    this.component = component;
  }

  _createClass(ValueTransformer, [{
    key: 'valueFromPosition',
    value: function valueFromPosition(position) {
      var sizePerc = this.percentageFromPosition(position);
      var valueDiff = this.component.props.maxValue - this.component.props.minValue;
      var value = this.component.props.minValue + valueDiff * sizePerc;

      return value;
    }
  }, {
    key: 'positionFromValue',
    value: function positionFromValue(value) {
      var length = this.component.trackClientRect.width;
      var valuePerc = this.percentageFromValue(value);
      var positionValue = valuePerc * length;

      return {
        x: positionValue,
        y: 0
      };
    }
  }, {
    key: 'positionFromEvent',
    value: function positionFromEvent(event) {
      var trackClientRect = this.component.trackClientRect;
      var length = trackClientRect.width;

      var _ref = event.touches ? event.touches[0] : event;

      var clientX = _ref.clientX;

      var position = {
        x: (0, _util.clamp)(clientX - trackClientRect.left, 0, length),
        y: 0
      };

      return position;
    }
  }, {
    key: 'percentageFromPosition',
    value: function percentageFromPosition(position) {
      var length = this.component.trackClientRect.width;
      var sizePerc = position.x / length;

      return sizePerc || 0;
    }
  }, {
    key: 'percentageFromValue',
    value: function percentageFromValue(value) {
      var validValue = (0, _util.clamp)(value, this.component.props.minValue, this.component.props.maxValue);
      var valueDiff = this.component.props.maxValue - this.component.props.minValue;
      var valuePerc = (validValue - this.component.props.minValue) / valueDiff;

      return valuePerc || 0;
    }
  }, {
    key: 'stepValueFromValue',
    value: function stepValueFromValue(value) {
      return Math.round(value / this.component.props.step) * this.component.props.step;
    }
  }]);

  return ValueTransformer;
})();

exports['default'] = ValueTransformer;
module.exports = exports['default'];