'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.maxMinValuePropType = maxMinValuePropType;

var _util = require('./util');

function numberPredicate(value) {
  return typeof value === 'number';
}

function maxMinValuePropType(props) {
  var maxValue = props.maxValue;
  var minValue = props.minValue;
  var value = props.value;
  var values = props.values;
  var defaultValue = props.defaultValue;
  var defaultValues = props.defaultValues;

  if (!values && !defaultValues && !numberPredicate(value) && !numberPredicate(defaultValue)) {
    return new Error('`value` or `defaultValue` must be a number');
  }

  if (!value && !defaultValue && !(0, _util.objectOf)(values, numberPredicate) && !(0, _util.objectOf)(defaultValues, numberPredicate)) {
    return new Error('`values` or `defaultValues` must be an object of numbers');
  }

  if (minValue >= maxValue) {
    return new Error('`minValue` must be smaller than `maxValue`');
  }

  if (maxValue <= minValue) {
    return new Error('`maxValue` must be larger than `minValue`');
  }

  if (value < minValue || value > maxValue) {
    return new Error('`value` must be within `minValue` and `maxValue`');
  }
}